=== Modules/Core/ImageAdaptors/CMakeLists.txt ===
project(ITKImageAdaptors)
itk_module_impl()
