=== Modules/Core/TestKernel/CMakeLists.txt ===
project(ITKTestKernel)
set(ITKTestKernel_LIBRARIES ITKTestKernel)
itk_module_impl()
