=== Modules/IO/Mesh/CMakeLists.txt ===
project(ITKIOMesh)
itk_module_impl()
