=== Modules/Bridge/NumPy/test/CMakeLists.txt ===
itk_module_test()
