=== Modules/IO/MINC/wrapping/CMakeLists.txt ===
itk_wrap_module(ITKIOMINC)
itk_auto_load_and_end_wrap_submodules()
